import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_helper/src/Views/PaginationView.dart';
import 'package:quiver/iterables.dart';

class CustomGridView extends StatelessWidget {
  final List<Widget> children;
  final double itemCount;
  final Future<void> Function() callback;

  CustomGridView({
    this.children,
    this.itemCount,
    this.callback
  });

  @override
  Widget build(BuildContext context) {
    return PaginationView(child: (scrollController, circularProgressIndicator) {
      return LayoutBuilder(builder: (context, constraints) {
        if (constraints.maxWidth < 600) {
          return Scrollbar(
            child: ListView(
              controller: scrollController,
              children: [...children, circularProgressIndicator],
            ),
          );
        } else {
          return Scrollbar(
            child: ListView(
              padding: EdgeInsets.zero,
              controller: scrollController,
              children: [...[for (final subChildren in partition(children, itemCount.toInt())) Row(crossAxisAlignment: CrossAxisAlignment.start, mainAxisAlignment: MainAxisAlignment.center, children: [for (final child in subChildren) child])], circularProgressIndicator],
            ),
          );
        }
      });
    }, callback: callback);
  }
}
